#include <iostream>

using namespace std;

int main()
{
    int N;
    long O, A, B, AB;
    cin >> N;
    cin >> O >> A >> B >> AB;

    string grupe[N];
    long broj[N];
    long m[N][4] = {0};

    for(int i = 0; i < N; i++) cin >> grupe[i] >> broj[i];

    long s1 = A + B + O + AB;
    long s2 = 0;
    for(int i = 0; i < N; i++) s2 += broj[i];

    bool b = true;

    if(s1 < s2) b = false;
    if(b)
    {
        for(int i = 0; i < N; i++)
        {
            if(grupe[i] == "O")
            {
                if(O >= broj[i])
                {
                    O -= broj[i];
                    m[i][0] = broj[i];
                }
                else
                {
                    b = false;
                    break;
                }
            }
        }
        if(b){
        for(int i = 0; i < N; i++)
        {
            if(grupe[i] == "A")
            {
                if(A >= broj[i])
                {
                    A -= broj[i];
                    m[i][1] = broj[i];
                }
                else if(A + O >= broj[i])
                {
                    m[i][1] = A;
                    m[i][0] = broj[i] - A;
                    A = 0;
                    O = O - broj[i] + A;
                }
                else
                {
                    b = false;
                    break;
                }
            }
        }
        }
        if(b){
        for(int i = 0; i < N; i++)
        {
            if(grupe[i] == "B")
            {
                if(B >= broj[i])
                {
                    B -= broj[i];
                    m[i][2] = broj[i];
                }
                else if(B + O >= broj[i])
                {
                    m[i][2] = B;
                    m[i][0] = broj[i] - B;
                    O = O - broj[i] + B;
                    B = 0;
                }
                else
                {
                    b = false;
                    break;
                }
            }
        }
        }
        if(b){
        for(int i = 0; i < N; i++)
        {
            if(grupe[i] == "AB")
            {
                if(AB >= broj[i])
                {
                    AB -= broj[i];
                    m[i][3] = broj[i];
                }
                else if(AB + O >= broj[i])
                {
                    m[i][3] = AB;
                    m[i][0] = broj[i] - AB;
                    O = O - broj[i] + AB;
                    AB = 0;
                }
                else if(AB + A >= broj[i])
                {
                    m[i][3] = AB;
                    m[i][1] = broj[i] - AB;
                    A = A - broj[i] + AB;
                    AB = 0;
                }
                else if(AB + B >= broj[i])
                {
                    m[i][3] = AB;
                    m[i][2] = broj[i] - B;
                    B = B - broj[i] + AB;
                    AB = 0;
                }
                else
                {
                    b = false;
                    break;
                }
            }
        }
        }
    }
    if(b)
    {
        cout << "moguce" << endl;
        for(int i = 0; i < N; i++){
            for(int j = 0; j < 4; j++) cout << m[i][j] << " ";
             if(i != N-1) cout << endl;
        }
    }
    else cout << "nemoguce";
    return 0;
}